-- Variables for the speed changes. 
-- 118 is roughly civilian walk speed assuming you have no movement speed changes.
local SLOW_WALK_SPEED = 118
_G.DEFAULT_WALK_SPEED = _G.DEFAULT_WALK_SPEED or tweak_data.player.movement_state.standard.movement.speed.STANDARD_MAX
_G.DEFAULT_CLIMBING_SPEED = _G.DEFAULT_CLIMBING_SPEED or tweak_data.player.movement_state.standard.movement.speed.CLIMBING_MAX
_G.DEFAULT_CROUCH_SPEED = _G.DEFAULT_CROUCH_SPEED or tweak_data.player.movement_state.standard.movement.speed.CROUCHING_MAX
_G.DEFAULT_ADS_SPEED = _G.DEFAULT_ADS_SPEED or tweak_data.player.movement_state.standard.movement.speed.STEELSIGHT_MAX

-- It's on a toggle. Not sure if I can make it a hold. Big thanks to Offeyerrocker for the help.
local player = managers.player and managers.player:local_player()
_G.toggle_walk_enabled = not _G.toggle_walk_enabled
if alive(player) then
    if _G.toggle_walk_enabled then
        tweak_data.player.movement_state.standard.movement.speed.STANDARD_MAX = SLOW_WALK_SPEED
        tweak_data.player.movement_state.standard.movement.speed.CROUCHING_MAX = SLOW_WALK_SPEED
        tweak_data.player.movement_state.standard.movement.speed.STEELSIGHT_MAX = SLOW_WALK_SPEED
		tweak_data.player.movement_state.standard.movement.speed.CLIMBING_MAX = SLOW_WALK_SPEED
    else
        tweak_data.player.movement_state.standard.movement.speed.STANDARD_MAX = _G.DEFAULT_WALK_SPEED
        tweak_data.player.movement_state.standard.movement.speed.CROUCHING_MAX = _G.DEFAULT_CROUCH_SPEED
        tweak_data.player.movement_state.standard.movement.speed.STEELSIGHT_MAX = _G.DEFAULT_ADS_SPEED
		tweak_data.player.movement_state.standard.movement.speed.CLIMBING_MAX = _G.DEFAULT_CLIMBING_SPEED
    end
end

-- This hook modifies headbob in order to give better feedback to the player if they're in the walking state.
-- Also just to make it look less visually disorienting.
Hooks:PostHook( PlayerStandard, "_get_walk_headbob", "super_unique_hook_name", function(self)
    local default_headbob = Hooks:GetReturn()

	if self._state_data.ducking and _G.toggle_walk_enabled and self._state_data.in_steelsight then 
		return 0
	elseif self._state_data.ducking and _G.toggle_walk_enabled then 
		return 0.004
	elseif self._state_data.using_bipod then
		return default_headbob
	elseif self._state_data.in_steelsight then
		return default_headbob
	elseif self._state_data.in_air then
		return default_headbob
	elseif self._running then
		return default_headbob
	elseif _G.toggle_walk_enabled then
		return 0.009
	end
end )
-- Holy mother of elseif.


--[[
Hooks:PostHook( PlayerMaskOff, "_get_walk_headbob", "bob", function(self)
	return 0
end )

An old version of the code above. It changes the function from the game's code itself. 
It works well enough, but is not ideal to use.

function PlayerStandard:_get_walk_headbob()
	if self._state_data.using_bipod then
		return 0
	elseif self._state_data.ducking and _G.toggle_walk_enabled then 
		return 0
	elseif self._state_data.in_steelsight then
		return 0
	elseif self._state_data.in_air then
		return 0
	elseif self._state_data.ducking then
		return 0.0125
	elseif self._running then
		return 0.1 * (self._equipped_unit:base():run_and_shoot_allowed() and 0.5 or 1)
	elseif _G.toggle_walk_enabled then
		return 0
	end

	return 0.025
end
]]